# class TCPSocket

- TCPSocket
- IPSocket
- Socket
- IO
- Reference
- Object

##
Overview

A Transmission Control Protocol (TCP/IP) socket.

Usage example:

    require "socket"

    client = TCPSocket.new("localhost", 1234)
    client << "message\n"
    response = client.gets
    client.close

##
Direct Known Subclasses

- TCPServer

##
Defined in:

##
Constructors

- .new(host, port, dns_timeout = nil, connect_timeout = nil)

  Creates a new TCP connection to a remote TCP server.

- .new(family : Family = Family::INET)

  Creates a new `TCPSocket`, waiting to be connected.

- .new(*, fd : Int32, family : Family = Family::INET)

  Creates a TCPSocket from an already configured raw file descriptor

##
Class Method Summary

- .open(host, port, &)

  Opens a TCP socket to a remote TCP server, yields it to the block, then eventually closes the socket when the block returns.

##
Instance Method Summary

- #tcp_keepalive_count

  The number of probes sent, without response before dropping the connection.

- #tcp_keepalive_count=(val : Int)
- #tcp_keepalive_idle

  The amount of time in seconds the connection must be idle before sending keepalive probes.

- #tcp_keepalive_idle=(val : Int)
- #tcp_keepalive_interval

  The amount of time in seconds between keepalive probes.

- #tcp_keepalive_interval=(val : Int)
- #tcp_nodelay=(val : Bool)

  Disables the Nagle algorithm when set to `true`, otherwise enables it.

- #tcp_nodelay?

  Returns `true` if the Nable algorithm is disabled.

### Instance methods inherited from class `IPSocket`

local_address local_address, remote_address remote_address

### Instance methods inherited from class `Socket`

accept : Socket accept, accept? accept?, bind(addr, &)
bind(host : String, port : Int)
bind(port : Int)
bind(addr) bind, blocking blocking, blocking=(value) blocking=, broadcast=(val : Bool) broadcast=, broadcast? broadcast?, close_on_exec=(arg : Bool) close_on_exec=, close_on_exec? close_on_exec?, close_read close_read, close_write close_write, closed? : Bool closed?, connect(addr, timeout = nil, &)
connect(addr, timeout = nil) : Nil
connect(host : String, port : Int, connect_timeout = nil) connect, family : Family family, fcntl(cmd, arg = 0) fcntl, fd : Int32 fd, finalize finalize, getsockopt(optname, optval, level = LibC::SOL_SOCKET) getsockopt, inspect(io : IO) : Nil inspect, keepalive=(val : Bool) keepalive=, keepalive? keepalive?, linger linger, linger=(val : Int?) linger=, listen(backlog : Int = SOMAXCONN)
listen(backlog : Int = SOMAXCONN, &) listen, protocol : Protocol protocol, receive(max_message_size = 512) : Tuple(String, Address)
receive(message : Bytes) : Tuple(Int32, Address) receive, recv_buffer_size recv_buffer_size, recv_buffer_size=(val : Int32) recv_buffer_size=, reuse_address=(val : Bool) reuse_address=, reuse_address? reuse_address?, reuse_port=(val : Bool) reuse_port=, reuse_port? reuse_port?, send(message, to addr : Address) : Int32
send(message) : Int32 send, send_buffer_size send_buffer_size, send_buffer_size=(val : Int32) send_buffer_size=, setsockopt(optname, optval, level = LibC::SOL_SOCKET) setsockopt, tty? tty?, type : Type type

### Constructor methods inherited from class `Socket`

new(fd : Int32, family, type, protocol = Protocol::IP, blocking = false)
new(family, type, protocol = Protocol::IP, blocking = false) new

### Class methods inherited from class `Socket`

fcntl(fd, cmd, arg = 0) fcntl, ip?(string : String) ip?, tcp(family : Family, blocking = false) tcp, udp(family : Family, blocking = false) udp, unix(type : Type = Type::STREAM, blocking = false) unix

### Instance methods inherited from module `IO::Evented`

evented_close evented_close, evented_read(slice : Bytes, errno_msg : String, &) : Int32 evented_read, evented_reopen evented_reopen, evented_send(slice : Bytes, errno_msg : String, &) : Int32 evented_send, evented_write(slice : Bytes, errno_msg : String, &) : Nil evented_write, read_timeout : Time::Span? read_timeout, read_timeout=(read_timeout : Number) : Number
read_timeout=(timeout : Time::Span?) : Time::Span? read_timeout=, write_timeout : Time::Span? write_timeout, write_timeout=(write_timeout : Number) : Number
write_timeout=(timeout : Time::Span?) : Time::Span? write_timeout=

### Instance methods inherited from module `IO::Buffered`

buffer_size buffer_size, buffer_size=(value) buffer_size=, close : Nil close, flush flush, peek : Bytes? peek, read(slice : Bytes) read, read_buffering=(read_buffering) read_buffering=, read_buffering? read_buffering?, rewind rewind, sync=(sync) sync=, sync? sync?, unbuffered_close unbuffered_close, unbuffered_flush unbuffered_flush, unbuffered_read(slice : Bytes) unbuffered_read, unbuffered_rewind unbuffered_rewind, unbuffered_write(slice : Bytes) unbuffered_write, write(slice : Bytes) : Nil write

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, gets(delimiter : Char, limit : Int, chomp = false) : String?
gets(delimiter : Char, chomp = false) : String?
gets(chomp = true) : String?
gets(limit : Int, chomp = false) : String?
gets(delimiter : String, chomp = false) : String? gets, gets_to_end : String gets_to_end, peek : Bytes? peek, pos pos, pos=(value) pos=, print(*objects : _) : Nil
print(obj) : Nil print, printf(format_string, *args) : Nil
printf(format_string, args : Array | Tuple) : Nil printf, puts(*objects : _) : Nil
puts : Nil
puts(obj) : Nil
puts(string : String) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, &) read_at, read_byte : UInt8? read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char? read_char, read_fully(slice : Bytes) read_fully, read_fully?(slice : Bytes) read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol? = nil) set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) write_bytes, write_utf8(slice : Bytes) write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : UInt64
copy(src, dst) : UInt64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &) pipe

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(host, port, dns_timeout = nil, connect_timeout = nil) #

Creates a new TCP connection to a remote TCP server.

You may limit the DNS resolution time with `dns_timeout` and limit the connection time to the remote server with `connect_timeout`. Both values must be in seconds (integers or floats).

Note that `dns_timeout` is currently ignored.

def self.new(family : Family = Family::INET) #

Creates a new `TCPSocket`, waiting to be connected.

def self.new(*, fd : Int32, family : Family = Family::INET) #

Creates a TCPSocket from an already configured raw file descriptor

##
Class Method Detail

def self.open(host, port, &) #

Opens a TCP socket to a remote TCP server, yields it to the block, then eventually closes the socket when the block returns.

Returns the value of the block.

##
Instance Method Detail

def tcp_keepalive_count #

The number of probes sent, without response before dropping the connection.

def tcp_keepalive_count=(val : Int) #
def tcp_keepalive_idle #

The amount of time in seconds the connection must be idle before sending keepalive probes.

def tcp_keepalive_idle=(val : Int) #
def tcp_keepalive_interval #

The amount of time in seconds between keepalive probes.

def tcp_keepalive_interval=(val : Int) #
def tcp_nodelay=(val : Bool) #

Disables the Nagle algorithm when set to `true`, otherwise enables it.

def tcp_nodelay? #

Returns `true` if the Nable algorithm is disabled.